/* -*- mode: c++; c-basic-offset: 4; -*-
 *
 * MICO --- a CORBA implementation
 * Copyright (C) 1997-98 Kay Roemer & Arno Puder
 * 
 * OSThread: An abstract Thread class for MICO
 * Copyright (C) 1999 Andy Kersting & Andreas Schultz
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Send comments and/or bug reports to:
 *                mico@informatik.uni-frankfurt.de
 *
 * $Id: dcethreads.cc,v 1.9 2000/01/08 00:57:15 aschultz Exp $
 *
 * support for Draft 4 (DCE) threads
 *
 */

#define MICO_CONF_IMR

#include <pthread.h>
#include <CORBA-SMALL.h>

//
// Global things (used/defined ONLY when HAVE_THREADS is defined)
//
#ifdef HAVE_THREADS  

static pthread_mutex_t __debug_mutex = PTHREAD_MUTEX_INITIALIZER;

void __mtdebug_init()
{
}

void __mtdebug_lock()
{
    pthread_mutex_lock( &__debug_mutex );
}

void __mtdebug_unlock()
{
    pthread_mutex_unlock( &__debug_mutex );
}

//
// No matter what the actual thread implementation is, _init ()
// takes care of initializing whatever has to be initialized.
//
static void MICOMT::_init (MICO_ULong _tpsize, MICO_ULong _tpincr) {
 
    THREAD_DEBUG( MT_TRACE( MICODebug::instance()->printer()
			    << "_init (_tpsize = " << _tpsize << ", _tpincr = "
			    << _tpincr << ")" << endl ));
}

//
// Thread::ThreadWrapper is a static member function that
// pthread_create(...) (or the like) can call as its "thread start routine".
// Any object whose methods are to be invoked as a thread, must derive from
// the class "Thread".  Thread has a method, _run(),
// which starts the Thread (or a derivative) "in motion".
//
void *
MICOMT::Thread::ThreadWrapper( void *arg )
{
    THREAD_DEBUG( MT_TRACE( MICODebug::instance()->printer()
			    << "ThreadWrapper()" << endl ));
    static_cast<Thread *>(arg)->_thr_startup( arg );
    THREAD_DEBUG( MT_TRACE( MICODebug::instance()->printer()
			    << "ThreadWrapper(): after calling _run()" << endl ));
 
    return NULL;          // the "start_routine" must return a void *.
}

/******* Mutex implementation *************************************************************************/
//
//   lock() and unlock() are inlined for optimal speed
//
MICOMT::Mutex::Mutex( MICO_Boolean locked, Attribute attr ) __NAME( :_namedObject () )
{
    name ("<UnNamed Mutex>");

    pthread_mutexattr_t m_attr;

    MUTEX_DEBUG( MT_TRACE( MICODebug::instance()->printer() 
			   << "Mutex::Mutex (locked = " << (int)locked << ", " 
			   << " attr = " << attr << ")" << endl ));

    pthread_mutexattr_create( &m_attr);
    if ( attr != Normal ) {
	switch (attr) {
	case Recursive: {
	    pthread_mutexattr_setkind_np( &m_attr, MUTEX_RECURSIVE_NP );
	    break;
	}
	}
    }
    assert( pthread_mutex_init(&_mutex, m_attr) == 0 );
    pthread_mutexattr_delete( &m_attr);
    if (locked) lock();
}

MICOMT::Mutex::~Mutex()
{ 
    MUTEX_DEBUG( MT_TRACE( MICODebug::instance()->printer()
			   << name () << ": Mutex::~Mutex ()" << endl ));
    pthread_mutex_destroy(&_mutex);
}
	
MICO_ULong
MICOMT::Mutex::trylock()
{
    MUTEX_DEBUG( MT_TRACE( MICODebug::instance()->printer()
			   << name () << ": Mutex::trylock ()" << endl ));
    switch (pthread_mutex_trylock (&_mutex)) {
    case 0:      return MICOMT::Thread::NoError;
    case EINVAL: return MICOMT::Thread::InvalidPriority;
    case EBUSY:  return MICOMT::Thread::MutexAlreadyLocked;
    };
    return MICOMT::Thread::UnknownError;
}

/******** condition variable ***************************************************************************/

MICOMT::CondVar::CondVar()
{
    pthread_condattr_t  c_attr;

    __NAME( name ("<UnNamed CondVar>") );
    COND_DEBUG( MT_TRACE( MICODebug::instance()->printer()
			  << name () << ": ContVar::CondVar ()" << endl ));

    pthread_condattr_create ( &c_attr );
    pthread_cond_init(&_cond, c_attr );
    pthread_condattr_delete ( &c_attr );
}

MICOMT::CondVar::~CondVar()
{
    COND_DEBUG( MT_TRACE( MICODebug::instance()->printer()
			  << name () << ": CondVar::~CondVar ()" << endl ));

    pthread_cond_destroy(&_cond);
}

/********* reader/writer implementation ***************************************************************/

MICOMT::rwLock::rwLock() __NAME( : _namedObject() )
{
    name ("<UnNamed rwLock>");
    pthread_mutexattr_t m_attr;
    pthread_condattr_t  c_attr;
    
    RWL_DEBUG( MT_TRACE( MICODebug::instance()->printer()
			 << "rwLock::rwLock ()" << endl ));

    pthread_mutexattr_create  ( &m_attr );
    pthread_condattr_create ( &c_attr );

    pthread_mutex_init( &lock, m_attr );
 
    pthread_cond_init( &readers, c_attr );
    pthread_cond_init( &writers, c_attr );
    
    state = waiters = 0;

    pthread_condattr_delete  (&c_attr);
    pthread_mutexattr_delete (&m_attr);
}

MICOMT::rwLock::~rwLock()
{
    RWL_DEBUG( MT_TRACE( MICODebug::instance()->printer()
			 << name () << ": rwLock::~rwLock ()" << endl ));
    pthread_mutex_destroy( &lock );
    pthread_cond_destroy( &readers );
    pthread_cond_destroy( &writers );
}

void MICOMT::rwLock::rdlock()
{
    RWL_DEBUG( MT_TRACE( MICODebug::instance()->printer() << name () << ": rwLock::rdlock ()" << endl ));
    pthread_mutex_lock( &lock );
    pthread_cleanup_push( reinterpret_cast<void (*)(void *)>(pthread_mutex_unlock),
			  &lock );
    while ( state < 0 && waiters)
	pthread_cond_wait( &readers, &lock );
    state++;
    pthread_cleanup_pop( 1 );         
}

void MICOMT::rwLock::wrlock()
{
    RWL_DEBUG( MT_TRACE( MICODebug::instance()->printer() << name () << ": rwLock::wrlock ()" << endl ));
    pthread_mutex_lock( &lock );
    waiters++;
    pthread_cleanup_push( reinterpret_cast<void (*)(void *)>(pthread_mutex_unlock),
			  &lock );
    while ( state < 0 && waiters)
	pthread_cond_wait( &writers, &lock );
    state = -1;
    pthread_cleanup_pop( 1 );
}

void MICOMT::rwLock::unlock()
{
    RWL_DEBUG( MT_TRACE( MICODebug::instance()->printer() << name () << ": rwLock::unlock ()" << endl ));
    pthread_mutex_lock( &lock );
    if (state  == -1) {                                     // a writer is releasing
	state = 0;                                          // mark as available
	if (waiters)                                        // other queued writers?
	    pthread_cond_signal( &writers );
	else
	    pthread_cond_broadcast( &readers );
    } else {
	if (--state == 0)                                   // No more readers
	    pthread_cond_signal( &writers );
    }
    pthread_mutex_unlock( &lock );
}

MICO_Boolean MICOMT::rwLock::trywrlock()
{
    MICO_Boolean status = false;
    pthread_mutex_lock( &lock );
    if (!state && !waiters) { // No readers, no writers && no writers queued
	state = -1;
	status = true;
    }
    pthread_mutex_unlock( &lock );
    return ( status );
}

/********* Semaphore implementation *******************************************************************/
//
//   post() and wait() are inlined for optimal speed
//
MICOMT::Semaphore::Semaphore( unsigned int val ) __NAME( : _namedObject () )
{
    name ("<UnNamed Semaphore>");

    SEMA_DEBUG( MT_TRACE( MICODebug::instance()->printer()
			  << "Semaphore::Semaphore (val = " << (int)val << ")" << endl ));
    assert( sem_init( &s, 0, val) == 0 ); 
}

MICOMT::Semaphore::~Semaphore()
{
    SEMA_DEBUG( MT_TRACE( MICODebug::instance()->printer()
			  << name () << ": Semaphore::~Semaphore ()" << endl ));
    sem_destroy( &s );
}


/********* Thread implementation for DCE threads ********************************************************/

MICOMT::Thread::Thread (MICOMT::Thread::DetachFlag detached) __NAME( :_namedObject () )
{
    name ("<Un-Named Thread>");

    _detached = detached;
 
    THREAD_DEBUG( MT_TRACE( MICODebug::instance()->printer()
			    <<"Thread::Thread (detached = " << (int)(char)detached
			    << ")" << endl ));
#ifdef _THR_CREATE_AND_BLOCK
    create_thread();
#endif
}
 
//
// Start the thread ala JAVA:
//
MICOMT::Thread::ErrorType 
MICOMT::Thread::start (void *arg)
{
    //FIXME: whats that for ?
    _arg = arg;
 
    THREAD_DEBUG( MT_TRACE( MICODebug::instance()->printer()
			    << "Thread::start (void *arg)" << endl ));
#ifdef _THR_CREATE_AND_BLOCK
    _ready.unlock();
    return MICOMT::Thread::NoError;
#else
    return create_thread();
#endif
}
 
//
// see if the thread given by ThreadID `id' is the same as this
// thread:
//
MICO_Boolean
MICOMT::Thread::operator == (const MICOMT::Thread &thread) const
{
    THREAD_DEBUG( MT_TRACE( MICODebug::instance()->printer()
			    << "Thread::operator == ()" << endl ));
    return (MICO_Boolean)pthread_equal (thread.id(), id() );
}

//
// set the priority of this thread to `new_priority'.
// let's avoid using this if at all possible, some pthreads impls don't
// support it fully or at all:
//
void
MICOMT::Thread::priority (MICO_Long new_priority) {
}

//
// destoying the object that runs our thread is not a good idea
// kill it first
//
MICOMT::Thread::~Thread ()
{
    // make sure the thread is really finished, before we remove it data structures 
    wait();
    _ready.unlock();
    THREAD_DEBUG( MT_TRACE( MICODebug::instance()->printer()
			    << "Thread::~Thread()" << endl ));
}


#endif // HAVE_THREADS
